use 5.6.0;
use strict;
#------------------------------------------------------------------------------
# Base system functions for satsuki system
#			Copyright (C)2005-2007 nabe@abk / E-mail:nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Base;
#------------------------------------------------------------------------------
our $VERSION = '1.22';
#------------------------------------------------------------------------------
# ʸɡ'EUC-JP', 'UTF-8' Τɤ餫侩
my $SYSTEM_CODING = 'EUC-JP';
my $SKELTON_CACHE_DIR = '__cache/';
my $_SALT = '5hLPQEDcY8mZKFbluVgrvqiSCHWaOGeTUMsRNnJXfIkj4oBpd/A29tx67wy3z.10';
#------------------------------------------------------------------------------
use Satsuki::AutoLoader;
use Fcntl;		# for sysopen
# use Symbol;		# for File Handle Object
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	# 
	$self->{ROBJ}    = $self;	# root object is self
	$self->{VERSION} = $VERSION;
	$self->{ENV}     = \%ENV;
	$self->{ARGV}    = \@ARGV;
	$self->{INC}     = \%INC;
	$self->{Status}  = 200;			# HTTP status (200 = OK)
	$self->{Salt64chars}  = $_SALT;	# saltʸ
	$self->{Form_options} = {};		# form
	$self->{Loaded_lib}   = {};		# loadѥ饤֥Hash
	$self->{h}            = {};		# Hashƥݥʥ桼ѡ
	$self->{CGI_mode}     = 'cgi perl';
	$self->{headers}      = [];		# إåϥХåե

	# ʸɡѹѹΤȡ
	$self->{System_coding} = $SYSTEM_CODING;

	# մϢ
	$self->{TM} = time;
	$self->{WDAY_name} = ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'];
	$self->{AMPM_name} = ['am','pm','am'];	# , , 
	$self->init_tm();

	# ȥϢͥcall/jumpˤ̵¥롼ɻ
	$self->{Skelton_file_ex} = '.html';
	$self->{Jump_count}      = 0;
	$self->{Nest_count}      = 0;
	$self->{Nest_count_base} = 0;
	$self->{Nest_max}        = 99;

	# ѥι֤¸
	$self->{Compiler_tm} = $self->get_modtime_by_libfile( 'Satsuki/Base/Compiler.pm' );

	#-------------------------------------------------------------
	# ModPerl check
	#-------------------------------------------------------------
	if (exists $ENV{MOD_PERL}) { $self->init_for_mod_perl(); }

	#-------------------------------------------------------------
	# ȥ󥭥åϢ
	#-------------------------------------------------------------
	my $cache_dir = $self->get_filepath( $ENV{SATSUKI_SKELTON_CACHE_DIR} || $SKELTON_CACHE_DIR );
	if (-d $cache_dir && -w $cache_dir) {
		$self->{__cache_dir} = $cache_dir;
	}
	return $self;
}
#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ
###############################################################################
#------------------------------------------------------------------------------
# ȥå (ưץȤǽ˸ƤФ)
#------------------------------------------------------------------------------
sub start_up {
	my $self = shift;

	# conf եβ
	{
		my $cmd = $0;
		if (substr($^O,0,5) eq 'MSWin') { $cmd =~ tr|\\|/|; }
		my $cgi = substr($cmd, rindex($cmd, '/')+1);
		if ((my $x = rindex($cgi, '.'))>0) { $cgi=substr($cgi, 0, $x); }
		if ((my $x = rindex($cgi, '.'))>0) { $cgi=substr($cgi, 0, $x); }
		$self->{Conf_file}   = $cgi . '.conf.cgi';
		$self->{Conf_result} = $self->_call($self->{Conf_file});
	}
	# NPH?
	if ($self->{NPH_mode}) { $self->{CGI_mode} = 'NPH script'; }

	# ĶѿʤޤƤӽФƤʤä
	if (! $self->{Initialized_path}) { $self->init_path(); }

	# Last-Modified ѤνSpeedyCGIδط conf ϸˤ뤳ȡ
	$self->update_modtime_by_file($0);				# cgi file
	$self->update_modtime_by_libfile('Satsuki/Base.pm');		# Υե
	$self->update_modtime_by_libfile('Satsuki/Base/Compiler.pm');	# ѥɬܥ饤֥

	# ̿Ū顼ä硢ɽƽλ
	if ($self->{Error_flag}) {
		my $err = join("\n", @{ $self->{Error} });
		$self->error_exit($err);
	}

	# ᥤ롼μ¹
	my $main = $self->{Main};
	if (defined $main && $main->can('main')) {
		$main->main();
	} else {
		$self->simple_main();	# Υ롼
	}

	# λ
	$self->finish();
}

#------------------------------------------------------------------------------
# conf.cgi Ȥ򤽤Τޤ޽ϤΥᥤ롼
#------------------------------------------------------------------------------
sub simple_main {
	my $self = shift;
	$self->print_lastmodified();
	$self->print_content_type($self->{Content_type} || "text/html");
	$self->output_array($self->{Conf_result});
}

#------------------------------------------------------------------------------
# ν
#------------------------------------------------------------------------------
sub init_tm {
	my ($self, $tz) = @_;
	my $h = $self->time2timehash( $self->{TM} );
	$self->{Now} = $h;
	$self->{Timestamp} = sprintf("%04d/%02d/%02d %02d:%02d:%02d",
			$h->{year}, $h->{mon}, $h->{day}, $h->{hour}, $h->{min}, $h->{sec});
}

#------------------------------------------------------------------------------
# ĶѿʥѥϤʤɡ
#------------------------------------------------------------------------------
# ưǧĶApache 1.3.x/2.x, lighttpd, AnHttpd
# Last update : 2006/11/10 --- ʬ̵Ǥ˽񤭴ʤǤ
#
sub init { &init_path(@_); }
sub init_path {
	my ($self, $force) = @_;
	if (!$force && $self->{Initialized_path}) { return; }

	# cgi ե̾μ$ENV{SCRIPT_NAME} ϥ󥿥륵ФǤϿѤǤʤ
	my $cgi_file = $0;
	$cgi_file =~ s|\\|/|g;	# for Windows environment
	if ($cgi_file =~ m|/([^/]*)$|) { $cgi_file=$1; }
	$self->{CGI_file} = $cgi_file;
	# cgi ե̾ǥ쥯ȥѹ sub set_protocol {} ˤԤȡ
	my $req_uri = $ENV{REQUEST_URI};
	if ((my $y = index($req_uri, '?')) >= 0) { $req_uri = substr($req_uri, 0, $y); }
	$req_uri =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/chr(hex($1))/eg;

	# modrewrite flag
	my $mod_rewrite = $self->{Mod_rewrite};
	if (!defined $mod_rewrite && exists $ENV{REDIRECT_URL} && $ENV{REDIRECT_STATUS}==200) { 
		if (index($req_uri, $cgi_file)<0) {	# Fail safe trap / URICGI̵̾
			$self->{Mod_rewrite} = $mod_rewrite = 1;
		}
	}

	# REQUEST URI ١ѥФ
	my $basepath = $self->{Basepath};
	my $request_base;
	if (!defined $basepath) {
		my $script = $ENV{SCRIPT_NAME};
		$request_base = $script;
		if (index($req_uri, $script)==0) {
			$basepath = substr($script, 0, length($script) - length($cgi_file));
		} else {
			while($request_base =~ m|^(.*/)[^/]+?/?$|) {
				$request_base = $1;
				if (index($req_uri, $request_base)==0) { last; }
			}
			$basepath = $request_base;
			chop($request_base);	# Ǹ / 
		}
		$self->{Basepath} = $basepath;
		# Request_base  Fail safe trap
		if (index($req_uri, "$request_base/$cgi_file")==0) {
			$request_base .= "/$cgi_file";
		}
	} elsif($mod_rewrite) {
		$request_base = $basepath;
		chop($request_base);
	} else {
		$request_base = $basepath . $cgi_file;
	}

	# PATH_INFO ʸбΤ
	# REQUEST_URI  PATH_INFO 
	if (exists $ENV{PATH_INFO} && !$self->{Use_PATH_INFO_orig}) {
		$ENV{PATH_INFO_orig} = $ENV{PATH_INFO};
		$ENV{PATH_INFO} = substr($req_uri, length($request_base));
		$ENV{PATH_INFO} =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		if ($ENV{PATH_INFO} eq '' && $ENV{PATH_INFO_orig} ne '') {
			$ENV{PATH_INFO} = $ENV{PATH_INFO_orig};
		}
	}
	if (exists $ENV{QUERY_STRING} && !$self->{Use_QUERY_STRING_orig}) {
		$ENV{QUERY_STRING_orig} = $ENV{QUERY_STRING};
		if ($ENV{REQUEST_URI} =~ /\?(.*)/) { $ENV{QUERY_STRING} = $1; }
			else { delete $ENV{QUERY_STRING}; }
	}
	# Хѥ
	if ($self->{Use_relative_path}) { $basepath = './'; }
	# ʬȡʥץȡˤ˥ URL/path
	if (!exists $self->{Myself}) {
		if ($mod_rewrite) {
			$self->{Myself}  = $self->{Myself2} = $basepath;
		} elsif (substr($request_base, rindex($request_base, '/')+1) eq $cgi_file) {	# ̾cgi
			$self->{Myself}  = $basepath . $cgi_file;
			$self->{Myself2} = $basepath . $cgi_file . '/';	# PATH_INFO
		} else {	# cgi  DirectoryIndex
			$self->{Myself}  = $basepath;
			$self->{Myself2} = $basepath . $cgi_file . '/';	# PATH_INFO
		}
	}

	# ץȥȽ̡
	my $port = int($ENV{SERVER_PORT});
	my $protocol = $self->{Protocol};
	if (!defined $protocol) {	# ץȥ뼫ưȽ
		$protocol = 'http://';
		if ($port == 443) { $protocol = 'https://'; }
		$self->{Protocol} = $protocol;
	}
	if (! exists $ENV{SERVER_PORT}
	 || $port== 80 && $protocol eq 'http://'
	 || $port==443 && $protocol eq 'https://') { $port=''; }
	if ($port ne '') { $port = ':' . $port; }

	my $server_name = $self->{Server_name} || $ENV{SERVER_NAME};
	my $host_name   = $ENV{HTTP_HOST}      || $ENV{SERVER_NAME};
	$self->{Protocol}   = $protocol;
	$self->{Server_url} = $protocol . $server_name . $port;
	$self->{Host_url}   = $protocol . $host_name;
	$self->{Baseurl}    = $self->{Server_url} . $self->{Basepath};

	# USER_AGENTȽ
	my $agent = $ENV{HTTP_USER_AGENT};
	if (index($agent, 'w3m')==0) { $self->{Is_w3m} = 1; }		# w3mк
	if ($agent =~ /MSIE (\d)(\.\d)/) {
		$self->{Is_IE} = "$1$2";
		$self->{Agent_class} = "IE IE$1";
	} elsif ($agent =~ m|Firefox/(\d)(\.\d)|) {
		$self->{Is_Fx} = "$1$2";
		$self->{Agent_class} = "Fx Fx$1";
	} elsif ($agent =~ m|Opera/(\d)(\.\d+)|) {
		$self->{Is_Opera} = "$1$2";
		$self->{Agent_class} = "Opera O$1";
	} elsif ($agent =~ m|Safari/(\d+)|) {
		$self->{Is_Safari} = $1;
		$self->{Agent_class} = "Safari Sa$1";
	} elsif ($agent =~ m|Gecko/\d\d\d\d\d\d|) {
		$self->{Is_Fx} = 1;
		$self->{Agent_class} = "Fx";
	}
	if (! $self->{Is_IE}) { $self->{Agent_class} .= " NotIE"; }
	if (index($agent, 'Windows CE')>=0 || index($agent, 'NetFront')>=0) { $self->{Is_mobile}=1; }	# mobile

	# Ƚ
	   if ($agent =~ /DoCoMo/) { $self->{Is_phone}=$self->{Is_docomo}=2; }
	elsif ($agent =~ /^KDDI/)  { $self->{Is_phone}=$self->{Is_au}=2;     }
	elsif ($agent =~ /^(?:Vodafone|SoftBank|J-PHONE)/) {
		$self->{Is_phone} = $self->{Is_sb} = 2; }
	elsif ($agent =~ /WILLCOM|DDIPOCKET/) { $self->{Is_phone} =1; }	# 

	# copyright
	$ENV{PATH_INFO} eq '/__getcpy' && print "X-Satsuki-System: (c)nabe\@abk\n";
	# ѥȤϿ
	$self->{Initialized_path} = 1;
}

###############################################################################
# executor
###############################################################################
#------------------------------------------------------------------------------
# ѥѤΥǡ¹Ԥ
#------------------------------------------------------------------------------
sub execute {	# executor
	my ($self, $subroutine) = @_;
	if (ref $subroutine ne 'CODE') {
		my ($pack, $file, $line) = caller;
		$self->error_from("line $line at $file", "[executor] Can't execute string '%s'", $subroutine);
		return ;
	}

	#------------------------------------------------------------
	# ͥȥå̵¥롼ɻߡ
	#------------------------------------------------------------
	$self->{Nest_count}++;	# ѡΥͥȥ
	if ($self->{Nest_count} > $self->{Nest_max}) {
		my $err = $self->error_from('', '[executor] Too depth nested call (max %d)', $self->{Nest_max});
		$self->{Nest_count}--;
		$self->{Break} = 2;
		return "<h1>$err</h1>";
	}

	#------------------------------------------------------------
	# executorΡ
	#------------------------------------------------------------
	my @output;
	my $line;
	my $arybuf = $self->{__arybuf};
	{
		## $self->{Timer}->start($self->{__src_file});
		my $v_ref;
		eval{ &$subroutine(\@output, $self, $arybuf, $line, $v_ref); };
		$v_ref && ($self->{v} = $$v_ref);	# v᤹
		if ($self->{Exit_flag}) { $self->do_exit(@{ $self->{Exit_flag} }); }
		my $h = $self->{"times"} ||= {};
		## $h->{"$self->{__src_file}"} = $self->{Timer}->stop($self->{__src_file});
	}

	# break
	my $break = int($self->{Break});
	if (!$break && $@) {
		$self->error_from("line $line at $self->{__src_file}", "[executor] $@");
	}

	#------------------------------------------------------------
	# 
	#------------------------------------------------------------
	$self->{Nest_count}--;		# ͥȥ

	while($break) {
		my $break_level = abs($break);
		# braek level 1 ΤȤƱ call٥  break
		if ($break_level<2 && $self->{Nest_count} > $self->{Nest_count_base}) { last; }
		# braek level 2 ʾΤȤͥȥ٥ 0 ޤ break (super break)
		if ($break_level>1 && $self->{Nest_count} > 0) { last; }
		# ߤޤǤν̤˴
		if ($break < 0) { @output = (); }
		$self->{Break} = 0;
		# jump or call ?
		if ($self->{Jump_file}) {		# jump 
			$self->{Jump_count}++;
			if ($self->{Jump_count} < $self->{Nest_max}) {
				my ($jump_file, $jump_skelton_name) = ($self->{Jump_file}, $self->{Jump_skelton});
				undef $self->{Jump_file};
				undef $self->{Jump_skelton};
				push(@output, $self->__call($jump_file, $jump_skelton_name, @{ $self->{argv} }));
			} else {
				my $err = $self->error_from('', "[executor] Too many jump (max %d)", $self->{Nest_max});
				push(@output, "<h1>$err</h1>");
			}
		}
		last;
	}

	return \@output;
}

###############################################################################
# ȥƤӽФ
###############################################################################
#------------------------------------------------------------------------------
# ٥ call
#------------------------------------------------------------------------------
my %skelton_memory_chace;
sub __call {
	my $self         = shift;
	my $src_file     = shift;
	my $skelton_name = shift;

	my $cache_dir  = $self->{__cache_dir};
	my $_cache_file = $src_file;
	my $src_filefull = $self->get_filepath($src_file);
	$_cache_file =~ s|\./||g;		# './' 
	$_cache_file =~ s/([^\w\.\#])/'%' . unpack('H2', $1)/eg;
	my $cache_file = $cache_dir . $_cache_file . '.cache';

	my ($errors, $arybuf, $cache_compiler_tm, $srouce_file_tm);
	my $orig_tm     = (stat($src_filefull))[9];
	my $cache_tm    = (stat($cache_file))  [9];


	if (!-r $src_filefull) {	# ɤ߹ʤ
		if ($cache_dir ne '') { unlink($cache_file); }	# å
		$self->error("[call] failed - Can't read file '%s'", $src_file);
		return undef;
	}
	# åեǧ
	$self->{Is_cache} = 0;
	my $loaded = 0;
	my $memory_cache_loaded = 0;
	if ($cache_dir ne '' && -r $cache_file && $orig_tm < $cache_tm) {
		#------------------------------------------------------------
		# ѥѥåɤ߹
		#------------------------------------------------------------
		# ꥭå夫
		if ($skelton_memory_chace{$src_filefull} == $cache_tm) {
			$arybuf            = $skelton_memory_chace{"arybuf_$src_filefull"};
			$cache_compiler_tm = $skelton_memory_chace{"compiler_tm_$src_filefull"};
			$srouce_file_tm    = $skelton_memory_chace{"srouce_file_tm$src_filefull"};
			$memory_cache_loaded = 1;
		} else {	# ե뤫
			($errors, $arybuf, $cache_compiler_tm, $srouce_file_tm) = $self->load_cache($cache_file);
		}
		if ($errors || $cache_compiler_tm != $self->{Compiler_tm} || $srouce_file_tm != $orig_tm) {
			$self->{Debug_mode} && $self->debug("Unload cache file '$src_file'.\n", '');
			$memory_cache_loaded = 0;
			unlink($cache_file);
		} else {
			$self->{Is_cache} = 1;
			$loaded = 1;	# 
		}
	}
	# å夬ɤ߹뤫
	if (! $loaded) {	# ̤
		#------------------------------------------------------------
		# ѥĤ
		#------------------------------------------------------------
		my $compile_log = $self->get_filepath( $self->{Compile_log_dir} );
		if ($compile_log ne '' && (-d $compile_log || $self->mkdir($compile_log)) ) {
			my $file = $src_file;
			$file =~ s|/|_-_|g;
			$file =~ s/[^\w\-\.]/_/g;
			$compile_log .= $file;	# log Ĥ
		} else {
			undef $compile_log;
		}
		#------------------------------------------------------------
		# ѥ
		#------------------------------------------------------------
		if ($cache_dir ne '') { unlink($cache_file); }	# å
		my $c     = $self->loadpm('Base::Compiler');
		my $lines = $self->fread_lines($src_filefull);
		($errors, $arybuf) = $c->compile($lines, $compile_log);

		#------------------------------------------------------------
		# å¸
		#------------------------------------------------------------
		if ($cache_dir ne '' && $errors == 0) {
			$self->save_cache($cache_file, $src_filefull, $orig_tm, $arybuf);
		}
		#------------------------------------------------------------
		# ѥ륨顼
		#------------------------------------------------------------
		my $err_msg = $c->{error_msg};
		if ($#$err_msg >= 0) {
			foreach(@$err_msg) {
				# 1 = warrning flag
				$self->_error(1, '', "[Compile] $src_file : $_");
			}
			# 顼äƤ³ʼ¹ԡˤ
		}
	}

	#------------------------------------------------------------
	# ץ쥳ѥ
	#------------------------------------------------------------
	if (! $memory_cache_loaded) {
		my $error;
		foreach (@$arybuf) {
			eval "\$_ = $_";
			if ($@) { $self->error_from("at $src_file", "[perl-compiler] $@"); $error=1; }
		}
		if ($error) { return undef; }
	}

	#------------------------------------------------------------
	# ե륭åꥭå¸
	#------------------------------------------------------------
	if ($self->{Is_cache} && ! $memory_cache_loaded) {
		$skelton_memory_chace{"$src_filefull"}               = $cache_tm;
		$skelton_memory_chace{"arybuf_$src_filefull"}        = $arybuf;
		$skelton_memory_chace{"compiler_tm_$src_filefull"}   = $cache_compiler_tm;
		$skelton_memory_chace{"srouce_file_tm$src_filefull"} = $srouce_file_tm;
	}

	#------------------------------------------------------------
	# ¹Խ
	#------------------------------------------------------------
	my $c = $self->{__cont_level};
	local ($self->{argv}, $self->{__src_file}, $self->{__skelton}, $self->{__arybuf}, $self->{Nest_count_base});
	$self->{argv}            = \@_;
	$self->{__src_file}      = $src_file;
	$self->{__skelton}       = $skelton_name;
	$self->{__arybuf}        = $arybuf;
	$self->{Nest_count_base} = $self->{Nest_count};
	return $self->execute( $arybuf->[0] );
}

#------------------------------------------------------------------------------
# åΥ
#------------------------------------------------------------------------------
sub load_cache {
	my ($self, $file) = @_;
	my %cache;

	local $/ = "\0";	# ǥߥѹ
	my $lines = $self->fread_lines($file);
	# ǡǥߥ
	foreach(@$lines) { chop(); }

	shift(@$lines);	# սɤ߼Τ
	my $version = shift(@$lines);
	chop($version);		# LF
	$version = (split('=',$version))[1];
	if ($version < 1.01) { return (1); }	# 

	# ΥåѥΥॹ(UTC)
	my $cache_compiler_tm = shift(@$lines);
	# Υå˻ѤեΥॹ(UTC)
	my $srouce_file_tm    = shift(@$lines);

	# 롼Хåեɤ߹
	my @arybuf;
	my $arys = shift(@$lines) + 0;
	for(my $i=0; $i<$arys; $i++) {
		push(@arybuf, shift(@$lines));
	}
	# ͽ
	my $rows = shift(@$lines) + 0;
	for(my $i=0; $i<$rows; $i++) {
		shift(@$lines);
	}
	# ͽ
	my $rows = shift(@$lines) + 0;
	for(my $i=0; $i<$rows; $i++) {
		shift(@$lines);
	}
	# ͽ
	$rows = shift(@$lines) + 0;
	for(my $i=0; $i<$rows; $i++) {
		shift(@$lines);
	}

	# @$lines Ǥ뤫å
	if ($#$lines != -1) { return (2); }	# 

	return (0, \@arybuf, $cache_compiler_tm, $srouce_file_tm);
}

###############################################################################
# 湽ʸ
###############################################################################
#------------------------------------------------------------------------------
# ѡǽ
#------------------------------------------------------------------------------
sub break {
	my ($self, $break_level) = @_;
	$self->{Break} = int($break_level) || 1;
}

#------------------------------------------------------------------------------
# begin֥åμ¹
#------------------------------------------------------------------------------
sub exec {
	my $self = shift;
	my $ary  = shift;
	if (! @_) { return $self->execute($ary); }
	# 
	my $backup = $self->{argv};
	$self->{argv} = \@_;
	my $r = $self->execute($ary);
	$self->{argv} = $backup;
	return $r;
}

#------------------------------------------------------------------------------
# ̥եɤ߹
#------------------------------------------------------------------------------
sub include {
	my $self = shift;
	my ($file) = @_;

	my $lines = $self->fread_lines($file);
	return $lines;
}
#------------------------------------------------------------------------------
# ̥եؤνܹ
#------------------------------------------------------------------------------
sub jump {
	my $self = shift;
	my $file = shift;
	$file =~ s/[^\w\/]//g;
	my ($jump_file, $dummy, $skel_level) = $self->check_skelton($file);
	$self->{Jump_file}    = $jump_file;
	$self->{Jump_skelton} = $file;
	$self->{Break}        = int(shift) || 1;
	$self->{argv}         = \@_;
	$self->{__cont_level} = $skel_level -1;
}

# ٥ʥե
sub _jump {
	my $self              = shift;
	$self->{Jump_file}    = shift;
	$self->{Jump_skelton} = undef;
	$self->{Break}        = int(shift) || 1;
	$self->{argv}         = \@_;
}
#------------------------------------------------------------------------------
# 桼skelton ٥㤤ȥؤΰܹԡʷ³
#------------------------------------------------------------------------------
sub continue {
	my $self = shift;
	my $file = $self->{__skelton};
	if ($self->{__cont_level}<0) { die "Can't contnue($self->{__cont_level})."; }

	my ($jump_file, $dummy, $skel_level) = $self->check_skelton($file, $self->{__cont_level});
	$self->{Jump_file}    = $jump_file;
	$self->{Jump_skelton} = $file;
	$self->{Break}        = 1;
	$self->{argv}         = \@_;
	$self->{__cont_level} = $skel_level -1;
}

#------------------------------------------------------------------------------
# ̥եθƤӽФ
#------------------------------------------------------------------------------
sub call {
	my $self = shift;
	my $skelton_name = shift;
	$skelton_name =~ s/[^\w\/]//g;
	my ($call_file, $dummy, $skel_level) = $self->check_skelton($skelton_name);
	local ($self->{__cont_level});
	$self->{__cont_level} = $skel_level -1;
	return $self->__call($call_file, $skelton_name, @_);
}
# ٥륳ʥե
sub _call {
	my $self = shift;
	my $file = shift;
	return $self->__call($file, undef, @_);
}


###############################################################################
# ȥ󥷥ƥϢ
###############################################################################
#------------------------------------------------------------------------------
# ȥեγǧ
#------------------------------------------------------------------------------
# ¸ߤɤ߹߲ǽʤХե̾Хѥˤ֤
#
sub check_skelton {
	my ($self, $skelton_name, $level) = @_;
	my $x;
	my $skelton_path = $self->{Skelton_subdir} . $skelton_name;
	# 桼ȥͥ褹
	if (!defined $level) { $level=4; }
	if ($level>2 && $self->{User_skelton_dir3} ne '') {
		my $file = $self->{User_skelton_dir3} . $skelton_path . $self->{Skelton_file_ex};
		if (-r ($x = $self->get_filepath($file))) { return wantarray ? ($file, $x, 3): $file; }
	}
	if ($level>1 && $self->{User_skelton_dir2} ne '') {
		my $file = $self->{User_skelton_dir2} . $skelton_path . $self->{Skelton_file_ex};
		if (-r ($x = $self->get_filepath($file))) { return wantarray ? ($file, $x, 2): $file; }
	}
	if ($level>0 && $self->{User_skelton_dir} ne '') {
		my $file = $self->{User_skelton_dir} . $skelton_path . $self->{Skelton_file_ex};
		if (-r ($x = $self->get_filepath($file))) { return wantarray ? ($file, $x, 1): $file; }
	}
	# ɸॹȥ
	my $file = $self->{Skelton_dir} . $skelton_path . $self->{Skelton_file_ex};
	if (!-r ($x = $self->get_filepath($file))) { return wantarray ? ($file, $x, -1): undef; }
	return wantarray ? ($file, $x, 0): $file;
}


###############################################################################
# λ̿
###############################################################################
#------------------------------------------------------------------------------
# λʽλեå롼θƤӽФѿ
#------------------------------------------------------------------------------
sub finish {
	my $self = shift;
	#
	# λեå롼θƤӽФ
	#
	my $hook_list = $self->{Endhook_list};
	$self->{Endhook_list} = 'end';		# ̵¥롼ɻ

	if (ref $hook_list eq 'ARRAY') {
		my @list = sort {$a->{level} <=> $b->{level}} @$hook_list;
		foreach (@list) {
			&{$_->{func}}( @{$_->{arg}} )
		}
	}
	#
	# 顼ɽ
	#
	my $error = $self->{Error};
	if (ref($error) && @$error) {
		if ($ENV{SERVER_PROTOCOL}) { print "<hr><strong>(ERROR)</strong><br>\n"; } else { print "\n\nERROR:" }
		print join("\n", @$error);
	}

	# ꡼кʽ۴ĻȲ
	foreach(keys(%$self)) {
		if (ref($self->{$_})) { $self->{$_} = undef; }
	}
}
#------------------------------------------------------------------------------
# 顼ˤ뽪λ
#------------------------------------------------------------------------------
# sub error_exit {} is source file split.
#------------------------------------------------------------------------------
# λ
#------------------------------------------------------------------------------
sub exit {
	my $self = shift;
	$self->finish();	# λ

	# mod_perl2 ˤ eval  exit ʤкexecutor ȡ
	$self->{Exit_flag} = \@_;
	$self->{Break}     = -2;
	# exit
	if ($self->{Not_exit}) { die(@_); }
	exit(@_);
}
sub do_exit {
	my $self = shift;
	if ($self->{Not_exit}) { die(@_); }
	exit(@_);
}


###############################################################################
# Ͻ
###############################################################################
# γĥΤ˽ϤϡΥ롼Ѥ뤳ȡ
# ץ饰¦ǡľɸϤʤȡ
#------------------------------------------------------------------------------
# ɸ
#------------------------------------------------------------------------------
# ̤ʾʳǤϻѤʤ
sub print {
	my $self = shift;
	print @_;
}

#------------------------------------------------------------------------------
# إå
#------------------------------------------------------------------------------
sub print_header {
	my ($self, $name, $val) = @_;
	# print "$name: $val\n";
	push(@{ $self->{headers} }, "$name: $val\n");
	if ($name eq 'Status') { $self->{Status_header} = $val; }
}

#------------------------------------------------------------------------------
# content_typeϡʥإåκǸ˽Ϥ뤳ȡ
#------------------------------------------------------------------------------
sub print_content_type {
	my ($self, $content_type, $charset) = @_;
	if ($self->{No_httpheader}) { return; }
	# is NHP?
	if ($self->{NHP_mode}) {
		my $status = $self->{Status_header} || '200 OK';
		print "HTTP/1.0 $status\n";
	}
	print @{ $self->{headers} };	# ¾Υإå
	$self->{headers} = [];
	# Content-Type;
	$charset ||= $self->{System_coding};
	$content_type ||= $self->{Content_type} || "text/plain";
	print "Content-Type: $content_type; charset=$charset;\n\n";
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub output_array {
	my ($self, $ary, $fh) = @_;
	if (!$fh && $self->{Status} == 304) { return; }
	$fh ||= *STDOUT;
	if (ref($ary) eq 'SCALAR') { print $fh $$ary; return; }
	return $self->_output_array( $ary, $fh );
}
sub _output_array {
	my ($self, $ary, $fh) = @_;
	foreach(@$ary) {
		if (ref $_ eq 'ARRAY') {
			$self->_output_array($_, $fh);
		} else {
			print $fh $_;
		}
	}

}

###############################################################################
# ̿ʾ᡿͡ϥå
###############################################################################
#------------------------------------------------------------------------------
# ¹
#------------------------------------------------------------------------------
# 裱TRUE ΤȤ裲¹ԡFALSEΤȤ 裳¹Ԥ
sub ifexec {
	my $self = shift;
	my ($exp, $obj1, $obj2) = @_;
	if (defined $obj1 && $exp) { return $self->execute( $obj1 ); }
	if (defined $obj2)         { return $self->execute( $obj2 ); }
	return ;
}

#------------------------------------------------------------------------------
# ϥåط
#------------------------------------------------------------------------------
sub copy {
	if (ref $_[1] ne 'HASH') { return {}; }
	my %h = %{ $_[1] };
	return \%h;
}

sub into {
	my ($self, $out, $in) = @_;
	if (! ref($in )) { return {}; }
	if (! ref($out)) { $out = {}; }
	while(my ($k,$v) = each(%$in)) {
		$out->{$k} = $in->{$k};
	}
	return $out;
}

###############################################################################
# ʸ
###############################################################################
#------------------------------------------------------------------------------
# ̤ &nbsp; ֤
#------------------------------------------------------------------------------
sub undef2nbsp {
	my $self = shift;
	foreach(@_) {
		if ($_ eq '') { $_ = '&nbsp;'; }
	}
}

#------------------------------------------------------------------------------
# ʸ
#------------------------------------------------------------------------------
sub string2ary {
	my ($self, $secure_id) = @_;
	return [ map { ord($_) } split('', $secure_id) ];
}

#------------------------------------------------------------------------------
# Υ
#------------------------------------------------------------------------------
sub tag_escape {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$_ =~ s/"/&quot;/g;
		$_ =~ s/{/&#123;/g;		# CSSXSSк
	}
	return $_[0];
}

sub tag_escape_amp {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/&/&amp;/g;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$_ =~ s/"/&quot;/g;
		$_ =~ s/{/&#123;/g;		# CSSXSSк
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# ν
#------------------------------------------------------------------------------
sub tag_delete {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/<\/.*?>//sg;
		$_ =~ s/<\w(?:[^>"']|[=\s]".*?\"|[=\s]'.*?')*?>//sg;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# URI󥳡
#------------------------------------------------------------------------------
# URLURL injectionˤʤɤɤؿ
#   http://xxxx/--/?a=1&b=2 ľ
sub uri_encode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/([^\.\/\~\*\-\w\#:;=\+\?&% ])/'%' . unpack('H2',$1)/eg;
	}
	return $_[0];
}

# Query뤿δؿ
sub form_encode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/([^\.\/\~\*\-\w:;])/'%' . unpack('H2',$1)/eg;
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# ִɽ s///g;
#------------------------------------------------------------------------------
sub replace {
	my $self = shift;
	my ($data, $x, $y) = @_;
	if (ref $data ne 'ARRAY') {
		$_[0] =~ s/$x/$y/g;
		return $_[0];
	}
	foreach(@$data) {
		$_ =~ s/$x/$y/g;
	}
	return $data;
}

#------------------------------------------------------------------------------
# ե륵Ĵ
#------------------------------------------------------------------------------
sub size_format {
	my $self = shift;
	my $size = int(shift);
	my $unit = int(shift) || 1024;
	my $geta = int(shift) || 10;
	my @ary  = @_ || ('Byte', 'KB', 'MB', 'GB', 'TB');
	while(@ary) {
		my $x = shift(@ary);
		if ($size < $unit || !@ary) {
			return (int($size*$geta + 0.5)/$geta) . $x;
		}
		$size /= $unit;
	}
}

###############################################################################
# ⥸塼Ϣ
###############################################################################
#------------------------------------------------------------------------------
# ץ饰Υ
#------------------------------------------------------------------------------
sub loadpm {
	my $self = shift;
	my $pm   = shift;
	return $self->_loadpm('Satsuki::' . $pm, @_);
}

# 饤֥ʲ̥٥
sub _loadpm {
	my $self = shift;
	my $pm   = shift;
	if (! $self->{Loaded_lib}->{$pm}) {
		my $pm_file = $pm . '.pm';
		$pm_file =~ s|::|/|g;
		require $pm_file;
		# modperlʤɤδĶΤˡ¹Ԥɬפ롣
		$self->update_modtime_by_libfile($pm_file); # for Last-Modified
		$self->{Loaded_lib}->{$pm} = 1;
	}
	return $pm->new($self, @_);
}

###############################################################################
# ե
###############################################################################
#------------------------------------------------------------------------------
# ե̾βùmod_perl2Ȥθߴѡ
#------------------------------------------------------------------------------
sub get_filepath {
	my ($self, $file) = @_;
	if ($self->{WD} eq '' || $file eq '') { return $file; }
	if (substr($file, 0, 1) eq '/' ) { return $file; }
	if (substr($file, 0, 2) eq './') { $file = substr($file, 2); }
	return $self->{WD} . $file;
}

#------------------------------------------------------------------------------
# ե¸߳ǧ
#------------------------------------------------------------------------------
sub file_exists {
	my ($self, $file) = @_;
	if (-e $self->get_filepath($file)) { return 1; }
	return 0;
}
#------------------------------------------------------------------------------
# ե롧٤ƤιԤɤ߹
#------------------------------------------------------------------------------
# $array_ref = &fread_lines($file);
sub fread_lines {
	return &_fread_lines($_[0], 0, $_[1]);
}
sub fread_lines_no_lastmod {
	my $self = shift;
	return $self->_fread_lines(1, @_);
}
sub fread_lines_no_error {
	my $self = shift;
	return $self->_fread_lines(2, @_);
}

sub _fread_lines {
	my $self = shift;
	my ($flag, $file) = @_;
	if ($file eq '') { my @ary=<STDIN>; return \@ary; }
	my $_file = $self->get_filepath($file);

	my $fh; # = Symbol::gensym();
	if ( !sysopen($fh, $_file, O_RDONLY) ) {
		if ($flag & 2) { $self->warning("File can't read '$file'"); }
			else   { $self->error("File can't read '%s'", $file); }
	}
	$self->read_lock($_file, $fh);
	my @lines = <$fh>;
	close($fh);
	$self->read_unlock($_file);

	# for Last-Modified
	if (! ($flag & 1)) { $self->update_modtime_by_file($file); }

	return \@lines;
}


#------------------------------------------------------------------------------
# ե롧ɸϥåɤ߹
#------------------------------------------------------------------------------
# $rl_h = &fread_hash($file);
#	$rl_h->{key} = "data";
sub fread_hash_noupdate_modtime {
	return &fread_hash(@_[0,1], 1);
}
sub fread_hash_no_error {
	return &fread_hash(@_[0,1], 2);
}
sub fread_hash {
	my $self  = shift;
	my $file  = shift;
	my $flags = shift;
	my $lines;
	if (ref($file) eq 'ARRAY') { $lines = $file; }
	else { $lines = $self->_fread_lines($flags, $file); }

	my %h;
	my ($blockname, $key, $val);
	# my $apeends=0;
	foreach (@$lines) {
		# ֥å⡼
		if (defined $blockname) {
			if ($_ eq $blockname) {
				chomp($val);
				$h{$key} = $val;
				undef $blockname;
			} else {
				$val .= $_;
			}
			next;
		}
		# ̾⡼
		chomp($_);
		my $f = ord($_);
		if (!$f || $f == 0x23) { next; }	# Ƭ'#'ϥ
		# if ($_ eq '**') { $apeends++; next; }		# '**'apeend mark

		if ($f==0x2a && (my $x=index($_, '=<<')) >0) {	# *data=<<__BLOCK ֥åǡ
			$key       = substr($_, 1, $x-1);
			$blockname = substr($_, $x+3) . "\n";
			$val       = '';
			next;
		}
		# ɸ key=val ɽ
		my $x = index($_, '=');
		if ($x == -1) { next; }
		$key     = substr($_, 0, $x);
		$h{$key} = substr($_, $x+1);
	}
	# ɵ鼫ưľ
	#if ($self->{Fapeend_auto_rewrite} && $self->{Fapeend_auto_rewrite} <= $apeends) {
	#	$self->fwrite_hash($file, \%h);
	#}
	return \%h;
}

#-----------------------------------------------------------
# lock unlockƤӽФfor read
#-----------------------------------------------------------
# lock, unlock ̥ե
sub read_lock {
	my ($self, $file, $file_handle) = @_;
	if (defined $self->{Lock}) {
		return $self->{Lock}->read_lock($file, $file_handle);
	}
	flock($file_handle, 1);		# block lock for reading
}

sub read_unlock {
	my ($self, $file, $file_handle) = @_;
	if (defined $self->{Lock}) {
		return $self->{Lock}->read_unlock($file, $file_handle);
	}
}

###############################################################################
# åդե
###############################################################################
my %fread_lines_cache;
my %fread_hash_cache;
#------------------------------------------------------------------------------
# åդեRead
#------------------------------------------------------------------------------
sub fread_lines_cached {
	my ($self, $file, $flag) = @_;
	my $filefull = $self->get_filepath($file);
	my $modified = (stat($filefull)) [9];
	my $cache    = $fread_lines_cache{$filefull} || {};

	if (-r $filefull && $modified == $cache->{modified}) {
		$self->update_modtime( $cache->{modified} );
		my @ary = @{ $cache->{lines} };
		return \@ary;
	}
	# ե뤫ɤ߹
	my $lines = $self->_fread_lines( $flag+0, $filefull );
	$fread_lines_cache{ $filefull } = {lines => $lines, modified => $modified };
	my @ary = @$lines;
	return \@ary;
}
sub fread_lines_cached_no_error {
	return &fread_lines_cached( @_[0,1], 2 );
}

#------------------------------------------------------------------------------
# åդHASHեRead
#------------------------------------------------------------------------------
sub fread_hash_cached {
	my ($self, $file) = @_;
	my $filefull = $self->get_filepath($file);
	my $modified = (stat($filefull)) [9];
	my $cache    = $fread_hash_cache{$filefull} || {};

	if (-r $filefull && $modified == $cache->{modified}) {
		$self->update_modtime( $cache->{modified} );
		my %h = %{ $cache->{hash} };
		return \%h;
	}
	# ե뤫ɤ߹
	my $hash = $self->fread_hash( $filefull );
	$fread_hash_cache{ $filefull } = {hash => $hash, modified => $modified };
	my %h = %$hash;
	return \%h;
}

###############################################################################
# ¾եϢ
###############################################################################
#------------------------------------------------------------------------------
# եι򹹿
#------------------------------------------------------------------------------
sub touch {
	my $self = shift;
	my $file = $self->get_filepath($_[0]);
	if (!-e $file) { $self->fwrite_lines($file, []); }
	my ($now) = $self->{TM};
	utime($now, $now, $file);
}

#------------------------------------------------------------------------------
# ե򸡺
#------------------------------------------------------------------------------
# search_files("directory name", "file extension", $dir_flag);
#	ĥҤ ".txt" Τ褦˻ꤹ
#	ĥҤά硢٤ƤΥꥹȤ֤
#	$dir_flag =  1 ꤹȡǥ쥯ȥޤ᤹٤ƤΥꥹȤ֤
#	$dir_flag = -1 ꤹȥǥ쥯ȥΤߤΥꥹȤ֤
sub search_files {
	my $self = shift;
	my ($dir, $file_ex, $dir_flag) = @_;
	$dir = $self->get_filepath($dir);

	my $fh; # = Symbol::gensym();
	opendir($fh, $dir) || return [];
	my $len = length($file_ex);
	my @filelist;
	foreach(readdir($fh)) {
		if ($_ eq '.' || $_ eq '..' )  { next; }	# ./ ../ ̵
		# ǥ쥯ȥ̵ or ǥ쥯ȥΤ
		if ((!$dir_flag && -d "$dir$_") || ($dir_flag==-1 && !-d "$dir$_")) { next; }
		if ($len) {	# ĥһꤢ
			if (substr($_, -$len) ne $file_ex) { next; }	# Ǥ뤫ǧ
			# $_ = substr($_, 0, length($_) - $len);	# ĥ
		}
		push(@filelist, $_);
	}
	closedir($fh);

	## @filelist = sort @filelist;
	return \@filelist;
}

#------------------------------------------------------------------------------
# ǥ쥯ȥ꤫Хѥ
#------------------------------------------------------------------------------
sub get_relative_path {
	my ($self, $base, $file) = @_;
	if (ord($file) == 0x2f) { return $file; }	# / ǻϤޤ
	my $x = rindex($base, '/');
	if ($x<0) { return $file; }
	return substr($base, 0, $x+1) . $file;
}

###############################################################################
# ꡼եࡦĶѿ
###############################################################################
#------------------------------------------------------------------------------
# եɤ߹
#------------------------------------------------------------------------------
sub read_form {
	if ($ENV{REQUEST_METHOD} ne 'POST') { return ; }
	return &_read_form(@_);		# θƤӽФ (use AutoLoader)
}
#------------------------------------------------------------------------------
# ꡼
#------------------------------------------------------------------------------
sub read_query {
	my $self = shift;
	if ($self->{Query}) { return $self->{Query}; }
	if ($ENV{QUERY_STRING} eq '') { return {}; }

	my $jcode;
	if ($self->{UA_code}) { $jcode = $self->loadpm("Jcode"); }
	my @query = split(/&/, $ENV{QUERY_STRING});
	my %query;
	foreach (@query) {
		my ($name, $val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		$val =~ s/[\x00-\x08\x0b\x0c\x0e-\x1f\x7f]//g;	# TAB LF CRʳ楳ɤ
		# ɽFormʸɤɤȰ㤦
		if ($jcode) {
			$jcode->from_to( \$val, $self->{UA_code}, $self->{System_coding} );
		}
		$query{$name} = $val;
	}
	# save
	return ($self->{Query} = \%query);
}

#------------------------------------------------------------------------------
# PATH INFO 
#------------------------------------------------------------------------------
#  PATH_INFO = /xxx/yyy/zzz
sub read_path_info {
	my $self = shift;
	my $str = $ENV{PATH_INFO};
	# $str =~ s/\?.*//;	# ? ʹߤ̵
	my ($dummy, @pinfo) = split(/\//, $str . "\0");
	if (@pinfo) { chop($pinfo[$#pinfo]); }

	# save
	$self->{To_base} = "../" x ($#pinfo + 1);
	return ($self->{Pinfo} = \@pinfo);
}

#------------------------------------------------------------------------------
# ӸμIDμ
#------------------------------------------------------------------------------
sub get_phone_id {
	my $self = shift;
	if ($self->{Is_phone} != 2) { return; }
	my $agent = $ENV{HTTP_USER_AGENT};
	if (($self->{Is_docomo} && $agent =~ /; ?icc(\w+)\)/)		# FOMA¤ֹ
	 || ($self->{Is_au} && $ENV{HTTP_X_UP_SUBNO} =~ /^(\d+)\_/)	# au EZֹʥ֥饤ID
	 || ($self->{Is_sb} && $agent =~ m|/SN(\d+)|)			# J-PHONE, üꥢֹ
	) { $self->update_modtime($self->{TM}); return $1; }
	return ;
}


###############################################################################
# եƥϢ
###############################################################################
#------------------------------------------------------------------------------
# CSRFк롼
#------------------------------------------------------------------------------
sub make_csrf_check_key {
	my ($self, $base_string) = @_;		# ֤ϴְäƤޤ
	my $check_key = $self->crypt_by_string( $self->{Secret_phrase}, $base_string );
	return ($self->{CSRF_check_key} = $check_key);
}

#------------------------------------------------------------------------------
# üID롼
#------------------------------------------------------------------------------
sub make_secure_id {
	my ($self, $salt_base, $old, $len) = @_;
	my $secret = $self->{Secret_phrase};
	my $secure_time = $self->{Secure_time} || 3600;
	my $code=0;
	$old = int($old);
	if ($old >= 0) {
		$code = int($self->{TM} / $secure_time);
		$self->update_modtime($code * $secure_time);
	}
	my $id = $self->crypt_by_string($salt_base . ($code - $old), $secret); # 
	$id =~ tr/\//-/;
	return substr($id, 0, $len || $self->{Secure_id_len} || 12);
}

#------------------------------------------------------------------------------
# ʸ salt key Ȥ crypt
#------------------------------------------------------------------------------
# ʸƱΤͿСƱ SALT ʸ롣
#
my $salt_cache_salt64;
my %salt_cache;
my $salt_cache_tm;
my @salt_id_ary = (999983,724597,546173,284149,811337,450101,329309,109367);
sub crypt_by_string {
	my ($self, $salt_string, $secret) = @_;
	my $salt64str = $self->{Salt64chars};

	# SALTå奷ƥʣ֤˽
	if ($salt_cache_salt64 ne $salt64str || $salt_cache_tm < $self->{TM}) {
		%salt_cache=(); $salt_cache_tm = $self->{TM} + 3600;
		$salt_cache_salt64=$salt64str;
	}
	my $salt_cache_id = "$salt_string\x01$secret";
	if (exists $salt_cache{ $salt_cache_id }) { return $salt_cache{ $salt_cache_id }; }
	# SALT
	my $x;
	my $len = length($salt_string);
	for(my $i=0; $i<$len; $i++) {
		$x += ord(substr($salt_string, $i, 1)) * $salt_id_ary[$i & 7];
	}
	# 1
	my $salt = substr($salt64str, $x & 63,1) . substr($salt64str, ($x>>6) & 63,1);
	my $key  = substr(crypt($salt, $secret), 2);
	# 2
	$x     >>= 12;
	$salt    = substr($salt64str, $x & 63,1) . substr($salt64str, ($x>>6) & 63,1);
	$key     = substr(crypt($salt, $key), 2);
	# å
	$salt_cache{ $salt_cache_id } = $key;
	return $key;
}

###############################################################################
# Cookie
###############################################################################
#==============================================================================
# Cookieβ
#==============================================================================
sub get_cookie {
	my $self = shift;
	my %cookie;
	foreach (split(/; */, $ENV{HTTP_COOKIE})) {
		my ($name, $value) = split(/=/, $_);
		$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/chr(hex($1))/eg;
		if (ord($value)) {	# start char isn't 0x00
			$cookie{$name} = $value;
		} else {
			$cookie{$name} = &split_cookie($value);
		}
	}
	# save
	$self->{Cookie} = \%cookie;
}

#==============================================================================
# cookie ʬarray cookie, hash cookie 
#==============================================================================
sub split_cookie {
	my @array = split(/\0/, $_[0]);
	shift(@array);	# ɤ߼Τ

	my $flag = ord(shift(@array));
	if ($flag == 1) {		# array
		return \@array;
	} elsif ($flag == 2) {		# hash
		my ($k, %h);
		while($#array >= 0) {
			$k     = shift(@array);
			$h{$k} = shift(@array);
		}
		return \%h;
	}
}


###############################################################################
# Last-Modfied Ϣ
###############################################################################
#------------------------------------------------------------------------------
# Last-Modfied RFCǼ
#------------------------------------------------------------------------------
sub get_RFC_lastmodified {
	my $self = shift;
	return $self->rfc_date($self->{Lastmodified});
}

#------------------------------------------------------------------------------
# Last-Modfied 
#------------------------------------------------------------------------------
sub print_lastmodified {
	my ($self, $force) = @_;
	if ($self->{POST} || $self->{No_lastmodified}) { return; }

	my $modtime = $force || $self->{Lastmodified};
	$self->print_header('Last-Modified', $self->rfc_date( $modtime ));
	$self->print_header('Cache-Control', 'max-age=0');
	if($modtime <= $self->{If_modified_since}) {
		$self->print_header('Status', '304 Not Modified');	# Not Modified
		$self->{Status} = 304;
	}
}

#------------------------------------------------------------------------------
# Last-Modified ͤ򹹿
#------------------------------------------------------------------------------
# &update_modtime(utc_time);
sub update_modtime {
	my ($self, $time) = @_;
	if ($self->{Lastmodified} < $time ) { $self->{Lastmodified} = $time; }
	return $time;
}

# &update_modtime_by_file($filename);
sub update_modtime_by_file {
	my ($self, $file) = @_;
	my $x = $self->get_file_lastmodified($file);
	if ($self->{Lastmodified} < $x ) { $self->{Lastmodified} = $x; }
	return $x;
}
#
# 饤֥ե̾Ϥ
# &update_modtime_by_libfile($lib_filename);
sub update_modtime_by_libfile {
	my ($self, $file) = @_;
	my $x = $self->get_file_lastmodified($INC{$file});
	if ($self->{Lastmodified}     < $x ) { $self->{Lastmodified}     = $x; }
	if ($self->{Lastmodified_lib} < $x ) { $self->{Lastmodified_lib} = $x; }
	return $x;
}

#------------------------------------------------------------------------------
# Last-Modified 
#------------------------------------------------------------------------------
sub get_file_lastmodified {
	my ($self, $file) = @_;
	my $cache = $self->{__lastmodified_cache} ||= {};
	if ($cache->{$file}) { return $cache->{$file}; }
	my $filefull = $self->get_filepath($file);
	return ($cache->{$file} = (stat($filefull)) [9]);
}

sub get_modtime_by_libfile {
	my ($self, $file) = @_;
	foreach(@INC) {
		if (-e "$_/$file") { return (stat("$_/$file")) [9]; }
        }
}

###############################################################################
# ա
###############################################################################
#------------------------------------------------------------------------------
#RFCս
#------------------------------------------------------------------------------
# Sun, 06 Nov 1994 08:49:37 GMT  ; RFC 822, updated by RFC 2822
sub rfc_date {
	my $self = shift;

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($_[0]);
	my($wd, $mn);
	$wd = substr('SunMonTueWedThuFriSat',$wday*3,3);
	$mn = substr('JanFebMarAprMayJunJulAugSepOctNovDec',$mon*3,3);

	return sprintf("$wd, %02d $mn %04d %02d:%02d:%02d GMT"
		, $mday, $year+1900, $hour, $min, $sec);
}

#------------------------------------------------------------------------------
# ϥå
#------------------------------------------------------------------------------
# time2timehash($time_utc, $change_hour);
#	$change_hour	ѹ֤λ
#
sub time2timehash {
	my $self = shift;
	my $tm   = $self->change_hour(@_);

	my %h;
	$h{tm} = $tm;
	( $h{sec},  $h{min},  $h{hour},
	  $h{_day}, $h{_mon}, $h{year},
	  $h{wday}, $h{yday}, $h{isdst}) = localtime($tm);
	$h{year} +=1900;
	$h{_mon} ++;
	$h{mon} = sprintf("%02d", $h{_mon});
	$h{day} = sprintf("%02d", $h{_day});

	return \%h;
}

sub change_hour {
	my $self = shift;
	my ($tm, $change_hour) = @_;
	if (!defined $change_hour) { $change_hour = $self->{Change_hour}; }

	my ($sec, $min, $hour) = localtime($tm % 86400);
	if ($hour < $change_hour) {	# ѹ 
		$tm -= 86400;
	}
	return $tm;
}
#------------------------------------------------------------------------------
# եޥåȤ
#------------------------------------------------------------------------------
# tm_printf($format, $UTC, $change_hour);
#	$format		
#	$UTC		UTC
#
sub tm_printf {
	my $self = shift;
	my $str  = shift;
	my $tm   = $self->change_hour(@_);

	# This macro like 'strftime(3)' function.
	# ߴ%Y %y %m %d %I %H %M %S %w %s %e
	# ܸۤߴ  %j %k %l ʷѤߴ
	# ɽѹġ%a %p
	# ȼĥ%n, %i %L, %J %K
	my %h;
	$h{s} = $tm;
	($h{S}, $h{M}, $h{k}, $h{e}, $h{n}, $h{Y}, $h{w}, $h{j}, $h{isdst}) = localtime($tm);
	$h{y}  = sprintf("%02d", $h{Y} % 100);
	$h{Y} +=1900;
	$h{n} +=1;		# month
	$h{m}  = sprintf("%02d", $h{n});
	$h{d}  = sprintf("%02d", $h{e});
	$h{H}  = sprintf("%02d", $h{k});	# 24ɽ
	$h{M}  = sprintf("%02d", $h{M});
	$h{S}  = sprintf("%02d", $h{S});
	$h{a}  = $self->{WDAY_name}->[$h{w}];	# ̾
	$h{i}  = $h{k} % 12;			# 12ɽ( 0-11)
	$h{L}  = sprintf("%02d", $h{L});	# 12ɽ(00-11)2
	$h{l}  = $h{i} || 12;			# 12ɽ( 1-12)
	$h{I}  = sprintf("%02d", $h{l});	# 12ɽ(01-12)2
	$h{J}  = $h{H} + 24*($tm != $_[0]);	# 24+$change_hour ֽ
	$h{K}  = sprintf("%02d", $h{J});	# 24+$change_hour ֽ2
	$h{p}  = $self->{AMPM_name}->[ int($h{J}/12) ];	# 塢

	$str =~ s/%(\w)/$h{$1}/g;
	return $str;
}


###############################################################################
# åǥХϢ
###############################################################################
#------------------------------------------------------------------------------
# եΥ
#------------------------------------------------------------------------------
sub load_language_file {
	my ($self, $file) = @_;
	# ե
	my $msg_translate = $self->{Msg_translate} = $self->fread_hash_cached($file);
	# ƥθ
	if (exists $msg_translate->{system_coding}) {
		$self->{System_coding} = $msg_translate->{system_coding};
	}
}
#------------------------------------------------------------------------------
# å
#------------------------------------------------------------------------------
sub message_translate {
	my $self = shift;
	my $msg  = shift;
	my $msg_translate = $self->{Msg_translate};
	if ($msg_translate->{$msg} ne '') { $msg = $msg_translate->{$msg}; }
	if (@_) { return sprintf($msg, @_); }	# 
	return $msg;
}

#------------------------------------------------------------------------------
# å롼
#------------------------------------------------------------------------------
sub message {
	my $self = shift;
	my $msg  = shift;
	# 
	my $msg_translate = $self->{Msg_translate};
	if ($msg_translate->{$msg} ne '') { $msg = $msg_translate->{$msg}; }
	# 
	if (@_) { $msg = sprintf($msg, @_); }
	# å¸
	if (ref $self->{Message} ne 'ARRAY') { $self->{Message} = []; }
	$self->{Message_flag} = 1;
	$self->tag_escape($msg);
	push(@{$self->{Message}}, $msg);
}

#------------------------------------------------------------------------------
# ǥХ롼
#------------------------------------------------------------------------------
sub debug {
	$_[0]->{Debug_log} = 1;	# $self->{Debug_log}=1
	return &warning(@_);
}
sub warning {
	my ($self, $str) = @_;
	if (ref $self->{Debug} ne 'ARRAY') { $self->{Debug} = []; }
	$self->tag_escape($str);
	my ($pack, $file, $line) = caller(0);
	push(@{$self->{Debug}}, $str . "<!-- in $file line $line -->");
}

#------------------------------------------------------------------------------
# 顼롼
#------------------------------------------------------------------------------
# &error_from('error from', "ɽ륨顼");
# &error("ɽ륨顼");
sub error_from {
	my $self = shift;
	return $self->_error(0, @_);
}
sub error {
	my $self = shift;
	return $self->_error(0, undef, @_);
}

#---------------------------------------------------
# 顼ʼΡ
#---------------------------------------------------
sub _error {
	my ($self, $no_stop_flags, $from, $msg) = splice(@_, 0, 4);
	# 
	my $msg_translate = $self->{Msg_translate};
	if ($msg_translate->{$msg} ne '') { $msg = $msg_translate->{$msg}; }
	# 
	if (@_) { $msg = sprintf($msg, @_); }

	# 顼
	if (!defined $from) {
		my @froms;
		my ($pack, $file, $line);
		my $i=1;
		do {
			($pack, $file, $line) = caller($i++);
			$file = substr($file, rindex($file, '/') +1);
			push(@froms, "in $file line $line");
		} while (($pack eq __PACKAGE__ || $pack =~ /::DB_/) && $i<10);
		$from = pop(@froms);
		while(@froms) {
			$from = pop(@froms) . " ($from)";
		}
	}
	if ($from ne '') { $msg = "$msg ($from)"; }
	$self->tag_escape($msg);

	if (!$no_stop_flags) {
		$self->{Error_flag} = 1;
		if ($self->{Error_exit}) {
			$self->error_exit($msg);
		}
	}

	if (ref $self->{Error} ne 'ARRAY') { $self->{Error} = []; }
	push(@{$self->{Error}}, $msg);
	return $msg;
}

1;	# ޤʤ
