use strict;
#------------------------------------------------------------------------------
# Split from Base.pm for AutoLoader
#------------------------------------------------------------------------------
use Satsuki::Base ();
use Satsuki::Base_auto ();
package Satsuki::Base;
###############################################################################
# mod_perlѥȥåסnew ƤФ
###############################################################################
sub init_for_mod_perl {
	my ($self) = @_;

	# ե饰ΩƤ
	$self->{CGI_cache} = 1;
	$self->{Mod_perl}  = 1;
	$self->{CGI_mode}  = 'mod_perl';

	if ($ENV{MOD_PERL_API_VERSION} == 2) {
		 $self->init_for_mod_perl2();		# startup for mod_perl2
	} elsif (!exists $ENV{MOD_PERL_API_VERSION}) {	# mod_perl version1
		*CORE::exit = \&Apache::exit;
	}

	# Ūʥȥǥ쥯ȥС
	# mod_perl2 + thread ĶǤϡȥǥ쥯ȥ꤬ѹǤʤɬ
	# ե륭åХѥǹԤᡢmod_perlĶǤɬ
	#
	$self->{WD} = substr($0, 0, rindex($0, '/')+1); # dir
}

###############################################################################
# mod_perl2ѤΥȥåסʾ夫ƤФ
###############################################################################
sub init_for_mod_perl2 {
	my ($self) = @_;

	# ե饰ΩƤ
	$self->{Mod_perl2} = 1;
	$self->{CGI_mode}  = 'mod_perl2';

	if (defined $Apache2::MPM::VERSION) {
		$self->{Is_thread} = Apache2::MPM->is_threaded;
	}

	# 廲
	# mod_perl2 + thread Ķ prefork ĶǥƥȤ뤿˴ͭ1 ||
	# ModPerl::RegistryPrefork ʤɤȤмư chdir Τ thread ĶǤɬפʤ
	#if (1 || $self->{Is_thread}) {
	#	$self->{WD} = $wd;	# ȥǥ쥯ȥ(Working Direcotry)
	#}

	# mod_perl2 handler  Last-Modified إåϥХФѥå
	#  --> ˤ 304 Ǥ⡢ºݤ 200 ֤졢ʸƬ8KB٤֤֤
	if (defined $Apache2::RequestRec::VERSION) {
		my $headers_in = Apache2::RequestRec->headers_in();
		my $ifmod = $headers_in->{'If-Modified-Since'};
		# sample string : 'Wed, 15 Mar 2006 07:10:00 GMT'
		if (length($ifmod) == 29) {
			my $year = substr($ifmod, 12, 4) - 1900;
			my $mon  = substr($ifmod,  8, 3);
			$mon = int(index('JanFebMarAprMayJunJulAugSepOctNovDec', $mon)/3);
			my $day  = substr($ifmod,  5, 2);
			my $hour = substr($ifmod, 17, 2);
			my $min  = substr($ifmod, 20, 2);
			my $sec  = substr($ifmod, 23, 2);

			require Time::Local;
			$self->{If_modified_since} = Time::Local::timegm($sec,$min,$hour,$day,$mon,$year);
		}
	}
}

###############################################################################
# SpeedyCGIѤΥȥå
###############################################################################
my %lib_modtime;
#------------------------------------------------------------------------------
# SpeedyCGIѤΥ⥸塼ɥå
#------------------------------------------------------------------------------
#    mod_perl2 ˤ Apache2::Reload 
sub init_for_speedycgi {
	my ($self, $package) = @_;
	eval { require CGI::SpeedyCGI; };
	if ($@ || ! CGI::SpeedyCGI->i_am_speedy) { return ; }

	# ե饰ΩƤ
	$self->{CGI_cache} = 1;
	$self->{SpeedyCGI} = 1;
	$self->{CGI_mode}  = 'SpeedyCGI';

	# λեå롼Ͽ
	$self->regist_endhook(999, \&save_lib_modtime);

	# ɺѥѥåιå
	if ($self->check_lib_update('Satsuki::')) {
		CGI::SpeedyCGI->shutdown_next_time();	# ꥯȽλ奷åȥ
		if ($ENV{REQUEST_METHOD} ne 'POST') {	# POSTϥ쥯ȤǤʤΤǤΤޤ޽
			$self->redirect($ENV{REQUEST_URI});	# ƱURL˥쥯
		}
	}
}

###############################################################################
# FastCGIѤΥȥå
###############################################################################
#------------------------------------------------------------------------------
# FastCGIѤΥ⥸塼ɥå
#------------------------------------------------------------------------------
sub init_for_fastcgi {
	my ($self, $req_handler, $package) = @_;
	if (! $self->{IsFastCGI} && ! $FCGI::VERSION) { return ; }	# ե饰ǧ
	$self->{CGI_cache}= 1;
	$self->{FastCGI}  = 1;
	$self->{Not_exit} = 1;		# exit ʤ
	$self->{CGI_mode} = 'FastCGI';

	# λեå롼Ͽ
	$self->regist_endhook(999, \&save_lib_modtime);

	# ɺѥѥåιå
	if ($self->check_lib_update('Satsuki::')) {
		$self->{FastCGI_LastRequest} = 1;	# ꥯȽλ奷åȥ
		if ($ENV{REQUEST_METHOD} ne 'POST') {	# POSTϥ쥯ȤǤʤΤǤΤޤ޽
			$self->redirect($ENV{REQUEST_URI});	# ƱURL˥쥯
		}
	}
}

###############################################################################
# SpeedyCGI / FastCGIѤΥɥå֥롼
###############################################################################
#------------------------------------------------------------------------------
# ˥ɤ줿饤֥ι֤¸
#------------------------------------------------------------------------------
sub save_lib_modtime {
	while (my ($pkg, $file) = each(%INC)) {
		if (exists $lib_modtime{$file}) { next; }
		$lib_modtime{$file} = (stat($file)) [9];
	}
}

#------------------------------------------------------------------------------
# 饤֥꤬Ƥ뤫ǧ
#------------------------------------------------------------------------------
sub check_lib_update {
	my ($self, $package) = @_;
	$package =~ s[::][/]g;
	while(my ($file, $current_tm) = each(%lib_modtime)) {
		if ($package && index($file, $package) < 0) { next; }
		my $tm = (stat($file)) [9];
		if ($tm > $current_tm) {
			return 1;
		}
	}
	return 0;
}


###############################################################################
# ƥåѥ롼
###############################################################################
sub get_system_info {
	my ($self) = @_;
	my %h;
	my $v = $];
	if ($v >= 5.006) { $v =~ s/[\.0]+/./g; }
	$h{perl_version} = $v;
	$h{perl_cmd}     = $^X;
	return \%h;
}

sub read_check {
	my ($self, $file, $ok, $ng) = @_;
	if (-r $self->get_filepath($file)) { return $ok || 1; }
	$self->{Fail} = 1;
	return $ng || 0; 
}

sub write_check {
	my ($self, $file, $ok, $ng) = @_;
	if (-w $self->get_filepath($file)) { return $ok || 1; }
	$self->{Fail} = 1;
	return $ng || 0; 
}

sub lib_check {
	my ($self, $lib_name, $ok, $ng) = @_;
	$lib_name =~ s|::|/|g;
	eval { require "$lib_name.pm"; };
	if (!$@) { return $ok || 1; }
	return $ng || 0; 
}

1;	# ޤʤ
