#!/usr/local/bin/perl
use strict;
#-------------------------------------------------------------------------------
# ǡ١ץ饰 for PostgreSQL
#					(C)2006-03 nabe / ABK project
#-------------------------------------------------------------------------------
package Satsuki::DB_pg;
use Satsuki::AutoLoader;
use DBI;
our $VERSION = '1.00';
#-------------------------------------------------------------------------------
# ǡ١³° (DBI)
my $DB_attri = {AutoCommit => 1, RaiseError => 0, PrintError => 0};
#-------------------------------------------------------------------------------
# ͥס
my %Connection_pool;
our $DEBUG;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class     = shift;
	my $self      = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	my ($ROBJ, $database, $username, $password, $flag, $debug) = @_;
	$self->{ROBJ} = $ROBJ;	# root object save

	# 
	$DEBUG = $debug;
	$self->{_RDBMS}             = 'PostgreSQL';
	$self->{db_id}              = "pg.$database.";
	$self->{tableinfo_table}    = '_tableinfo';
	$self->{update_lastmodifed} = 1;
	$self->{lastmodified_cache} = {};

	# ͥ pool 
	my $dbh;
	my $connect_id = $self->{connect_id} = "$database\e$username\e$password";
	if ($flag) {
		if (exists $Connection_pool{$connect_id}) {	# ס뤬¸ߤ
			$dbh = $Connection_pool{$connect_id};	# ļФ
			if (! $dbh->ping) {
				$dbh = undef;
				delete $Connection_pool{$connect_id};
			}
			$DEBUG && $dbh && $ROBJ->debug("[DB_pg] pop from connection pool");
		}
	}
	# ³
	if (! $dbh) {
		$dbh = DBI->connect("DBI:Pg:$database", $username, $password, $DB_attri);
		if (!$dbh) { $ROBJ->error('[DB_pg] Connection faild'); return ; }
	}
	# ס뤹
	if ($flag) {
		$Connection_pool{$connect_id} = $dbh;
	}

	# ¸
	$self->{dbh} = $dbh;
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ơ֥
###############################################################################
#------------------------------------------------------------------------------
# ơ֥¸߳ǧ
#------------------------------------------------------------------------------
sub find_table {
	return &get_table_lastmodifed(@_);
}

#------------------------------------------------------------------------------
# ơ֥κǽ
#------------------------------------------------------------------------------
sub get_table_lastmodifed {
	my ($self, $table) = @_;
	$self->{no_tableinfo} && return $self->{ROBJ}->{tm};
	# åγǧ
	my $cache    = $self->{lastmodified_cache};
	my $cache_id = $self->{db_id} . $table;
	if ($cache->{$cache_id}) { return $cache->{$cache_id}; }

	my $tableinfo_table = $self->{tableinfo_table};
	my $dbh = $self->{dbh};
	my $sql = "SELECT tm FROM $tableinfo_table WHERE table_name='$table'";
	my $sth = $dbh->prepare($sql);
	$DEBUG && $self->debug($sql);		# debug
	$sth && $sth->execute();
	if (!$sth || $dbh->err) {	# Not found
		if ($table ne $tableinfo_table) {
			$self->update_lastmodifed_by_table( $tableinfo_table );
		}
		return 0;
	}
	return ($cache->{$cache_id} = $sth->fetchrow_array);
}

###############################################################################
# ǡθ
###############################################################################
sub select {
	my $timer = $_[0]->{ROBJ}->{Timer};
	$timer && $timer->start('db');
	my $r = _select(@_);
	$timer && $timer->stop('db');
	return $r;
}

sub _select {
	my ($self, $table, $h) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};
	$table =~ s/\W//g;

	#---------------------------------------------
	# Last-Modified ι
	#---------------------------------------------
	$self->update_lastmodifed_by_table( $table );

	#---------------------------------------------
	# ޥå󥰾ν
	#---------------------------------------------
	my $where;
	my @ary;
	while(my ($k,$v) = each(%{ $h->{match_int} })) {
		$k =~ s/\W//g;
		$where .= " AND $k=?";
		push(@ary, $v);
	}
	while(my ($k,$v) = each(%{ $h->{match_str} })) {
		$k =~ s/\W//g;
		$where .= " AND $k=?";
		push(@ary, $v);
	}
	while(my ($k,$v) = each(%{ $h->{min} })) {
		$k =~ s/\W//g;
		$where .= " AND $k>=?";
		push(@ary, $v);
	}
	while(my ($k,$v) = each(%{ $h->{max} })) {
		$k =~ s/\W//g;
		$where .= " AND $k<=?";
		push(@ary, $v);
	}
	while(my ($k,$v) = each(%{ $h->{flag} })) {
		$k =~ s/\W//g;
		if ($v) { $where .= " AND $k"; next; }
		$where .= " AND NOT $k";
	}
	foreach(@{ $h->{is_null} }) {
		$_ =~ s/\W//g;
		$where .= " AND $_ IS NULL";
	}
	foreach(@{ $h->{is_not_null} }) {
		$_ =~ s/\W//g;
		$where .= " AND $_ IS NOT NULL";
	}
	if ($h->{match_in_col} ne '' && ref($h->{match_in}) eq 'ARRAY') {
		my $col  = $h->{match_in_col};
		my $vals = $h->{match_in};
		push(@ary, @$vals);
		my $w = '?,' x ($#$vals+1);
		chop($w);
		if ($w ne '') {
			$col =~ s/\W//g;
			$where .= " AND $col in ($w)";
		}
	}
	if ($h->{search_cols}) {
		my $words = $h->{search_words};
		foreach my $word (@$words) {
			my $w = $word;
			$w =~ s/([\\%_])/\\$1/g;
			$w = "%$w%";
			my @x;
			foreach (@{ $h->{search_cols} }) {
				push(@x, "$_ ILIKE ?");
				push(@ary, $w);
			}
			$where .= " AND (" . join(' OR ', @x) . ")";
		}
	}
	if ($where) { $where = ' WHERE' . substr($where, 4); }

	#---------------------------------------------
	# Ͽ
	#---------------------------------------------
	if ($h->{require_hits}) {
		my $sql = "SELECT count(pkey) FROM $table$where";
		my $sth = $dbh->prepare($sql);
		$DEBUG && $self->debug($sql);	# debug
		$sth && $sth->execute(@ary);
		if (!$sth || $dbh->err) { $ROBJ->error($dbh->errstr); }
		$h->{hits} = $sth->fetchrow_array;
		$sth->finish();
	}

	#---------------------------------------------
	# SQL
	#---------------------------------------------
	# 륫
	my $cols = "*";
	my $select_cols = $h->{select_cols};
	if (ref($select_cols)) {
		foreach(@$select_cols) { $_ =~ s/\W//g; }
		$cols = join(',', @$select_cols);
	}
	# SQL
	my $sql = "SELECT $cols FROM $table$where";

	#---------------------------------------------
	# Ƚ
	#---------------------------------------------
	my $sort  = $h->{sort};
	my $sort2 = $h->{sort2};
	$sort  =~ s/\W//g;
	$sort2 =~ s/\W//g;

	if ($sort && $h->{sort_reverse}) { $sort .= ' DESC'; }
	if ($sort2) {
		$sort .= ', ' . $sort2;
		if ($h->{sort2_reverse}) { $sort .= ' DESC'; }
	}
	if ($sort) { $sort = ' ORDER BY ' . $sort; }
	$sql .= $sort;

	#---------------------------------------------
	# limit and offset
	#---------------------------------------------
	my $offset = int($h->{offset});
	my $limit;
	if ($h->{limit} ne '') { $limit = int($h->{limit}); }
	if ($offset > 0)  { $sql .= ' OFFSET ' . $offset; }
	if ($limit ne '') { $sql .= ' LIMIT '  . $limit;  }

	#---------------------------------------------
	# Do SQL
	#---------------------------------------------
	my $sth = $dbh->prepare($sql);
	$DEBUG && $self->debug($sql);	# debug
	$sth && $sth->execute(@ary);
	if (!$sth || $dbh->err) {
		if ($h->{no_error})  { $self->warning($sql); $self->warning($dbh->errstr); }
				else { $ROBJ->error($sql);   $ROBJ->error($dbh->errstr);   }
		return [];
	}

	return $sth->fetchall_arrayref({});
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ơ֥빹
#------------------------------------------------------------------------------
sub update_lastmodifed_by_table {
	my ($self, $table) = @_;
	if ($table eq '') { $table = $self->{tableinfo_table}; }
	return $self->{ROBJ}->update_modtime( $self->get_table_lastmodifed($table) );
}

#------------------------------------------------------------------------------
# ǥХå
#------------------------------------------------------------------------------
sub set_debug {
	my ($self, $flag) = @_;
	$DEBUG = $flag;
}
sub debug {
	my ($self, $sql) = @_;
	$self->{ROBJ}->debug('[PostgreSQL]' .$sql);
}
sub warning {
	my ($self, $sql) = @_;
	$self->{ROBJ}->warning('[PostgreSQL:ERROR] ' . $sql);
}



1;	# ޤʤ
